// OpOcean class definition,  describes a square array of TriState buttons
//                            and a status line for the opponents ships
// Copyright (C) 05.09.97 Marco Dettori and Oliver Obst
//
// $Id: opocean.h,v 0.2 1998/03/16 10:35:32 oliver Exp $

// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.

#ifndef OPOCEAN_H
#define OPOCEAN_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif


#include <qwidget.h>

#include "ocean.h"


class OpOcean : public Ocean
{
        Q_OBJECT
public:
        enum    State   { MYTURN, WAITING, OPTURN };
        
        OpOcean( char sql=0, char ships=0, char *lengths=0, char stlen = 11,
                 QWidget *parent=0, const char *name=0 );

        void    setState( State s );
        State   getState();
        
protected:
        char    len, num;
        char    *length;
        short   ship;
        State   state;

public slots:
        void    reset();
        void    report( int id, int result );

protected slots:
        void    handleClick();

signals:
        void    request( int id );
};
        
#endif OPOCEAN_H
