// SeaProto class definition
// Copyright (C) 04.09.97 Marco Dettori and Oliver Obst
//
// $Id: seaproto.h,v 0.2 1998/03/16 10:41:18 oliver Exp $
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.

#ifndef SEAPROTO_H
#define SEAPROTO_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#ifdef HAVE_TLI
#include <tiuser.h>
#include <arpa/inet.h>
#include <sys/fcntl.h>
#define DEV_TCP "/dev/tcp"
#endif HAVE_TLI

#include <netdb.h>
#include <netinet/in.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <qsocknot.h>

#include "protoconst.h"

class SeaProto : public QObject
{
        Q_OBJECT
public:
        SeaProto( const char *hostname="localhost", int portNr=17003,
                  QObject *parent=0, const char *name=0 );
        ~SeaProto();

        void    setServer( const char *hostname="localhost" );
        void    setPort( int portNr=17003 );
        int     seaOpen( char * player1, char * player0 = 0);
        void    seaClose( bool surrender = FALSE );
        bool    connected();

protected:
        bool            connection;
        
        char            *server;                // server name
        int             port;                   // server port number
        hostent         *server_info;           // info about server
        sockaddr_in     epAddr;                 // server address
        int             sockfd;                 // socket
        QSocketNotifier *sn;                    // notifier for socket        

#ifdef HAVE_TLI
        t_call          *callp;                 // tli endpoint memory pointer
#endif HAVE_TLI

public slots:
        void    writeReport( int id, int result );
        void    writePeek( int id );

protected slots:
        void    readSocket();

signals:
        void    defeat();
        void    request( int id );
        void    reporter( int id, int result );
};


#endif SEAPROTO_H
